

#ifndef COMPOUNDARG_H
#define COMPOUNDARG_H

#include <vector>
#include "param.h"

class compoundParam : public param
{
private:
    vector<param*> m_component;

public:
    compoundParam(const char flag, const string description, const int options, 
            int *numExamples, const int maxExamples);
    ~compoundParam();

    // add a new component to the compound parameter
    virtual void addComponent(param *component, const int MaxExamples=1);

    void initParam();
    virtual void printValue() const ;
    virtual void printType() const ;
    virtual void describeParam() const;
    virtual void setParam(char **arg);
    virtual bool wrongNumComponents() const ;
};
#endif
